#include <stdlib.h>
#include <stdio.h>
#define MAXWALLS 5
#define MAXALLOWEDWALLS 2
#define MAXPAINT 10
#define MAXPAINTPERWALL 4
FILE *fin;
int w,p,cash;
int minvalue,mincost,selw[MAXWALLS],selp[MAXPAINT],widthl[MAXWALLS],ppw[MAXWALLS];
struct {
	int width;
	int price;
} wall[MAXWALLS];
struct {
	int width;
	int price;
	int value;
} painting[MAXPAINT];

int globalselectedw[MAXWALLS];
int globalselectedp[MAXPAINT];

int globalwidthleft[MAXWALLS];
int globalposw,globalposp;
int globalcashleft,globalwallsleft;
int globalvalue, globalpaintperwall[MAXWALLS];

void solverec() {
	int saveposp;
	if (globalvalue>minvalue || (minvalue!=0 && globalvalue==minvalue && (mincost==0 || cash-globalcashleft<mincost))) {
		minvalue = globalvalue;
		mincost = cash-globalcashleft;
	}
	if (globalposw==w || globalposp==p)
		return;
	if (globalselectedw[globalposw]==0) {
	    if (globalwallsleft>0 && globalcashleft>=wall[globalposw].price) {
		int savewidthleft = globalwidthleft[globalposw];
		int saveposp = globalposp;
		int savecashleft= globalcashleft;
		int saveselectedw=globalselectedw[globalposw];
		globalselectedw[globalposw]=1;
		globalwidthleft[globalposw]=wall[globalposw].width-10;
		globalcashleft-=wall[globalposw].price;
		globalposp=0;
		globalwallsleft--;
		solverec();
		globalwallsleft++;
		globalposp=saveposp;
		globalcashleft=savecashleft;
		globalwidthleft[globalposw]=savewidthleft;
		globalselectedw[globalposw]=saveselectedw;
	    }
	} else {
		if (globalselectedp[globalposp]==0 && globalpaintperwall[globalposw]<MAXPAINTPERWALL && globalwidthleft[globalposw]>=painting[globalposp].width+10 && globalcashleft>=painting[globalposp].price) {
			int savewidthleft = globalwidthleft[globalposw];
			int savepaintperwall = globalpaintperwall[globalposw];
			int savecashleft = globalcashleft;
			int savevalue = globalvalue;
			int saveselectedp = globalselectedp[globalposp];
			globalselectedp[globalposp]=1;
			globalpaintperwall[globalposw]+=1;
			globalwidthleft[globalposw]-=painting[globalposp].width+10;
			globalcashleft-=painting[globalposp].price;
			globalvalue+=painting[globalposp].value;
			globalposp++;
			solverec();
			globalposp--;
			globalvalue=savevalue;
			globalcashleft=savecashleft;
			globalwidthleft[globalposw]=savewidthleft;
			globalpaintperwall[globalposw]=savepaintperwall;
			globalselectedp[globalposp]=saveselectedp;
		}
		globalposp++;
		solverec();
		globalposp--;
	}
	saveposp=globalposp;
	globalposw++;
	globalposp=0;
	solverec();
	globalposp=saveposp;
	globalposw--;
}
	
int main(void) {
        int run, i;
        /* fin = fopen("painting.in", "r"); */
        fin = stdin;
        fscanf(fin, "%d\n", &run);
        while ((run--) > 0) {
                fscanf(fin, "%d\n", &cash);
                fscanf(fin, "%d\n", &w);
                for (i=0;i<w;i++) {
                	fscanf(fin, "%d %d\n", &wall[i].width, &wall[i].price);
                	selw[i]=widthl[i]=ppw[i]=0;
                	globalselectedw[i]=globalwidthleft[i]=globalpaintperwall[i]=0;
                }
                fscanf(fin, "%d\n", &p);
                for (i=0;i<p;i++) {
                	fscanf(fin, "%d %d %d\n", &painting[i].width, &painting[i].price,&painting[i].value);
                	selp[i]=0;
                	globalselectedp[i]=0;
                }
                minvalue=0;
                mincost=0;
		globalposw=0;
		globalposp=0;
		globalcashleft=cash;
		globalwallsleft=MAXALLOWEDWALLS;
		globalvalue=0;
		
		solverec();
                printf("%d %d\n", mincost, minvalue);
        }
        fclose(fin);
        return 0;
}
