import java.io.*;


public class schilderijen
{
    
    public static void main (String args[]) {
        new schilderijen();
    }
    
    
    StreamTokenizer st;
        
    int MAX_M = 2;
    int MAX_S = 4;
    int m, s;
    int[][] ma;
    int[][] sa;
    int[][] mw = new int[MAX_M][4];
    int[][] sw = new int[MAX_S][4];
    
    int aantal_m;
    
    int max_budget, budget, pub_waarde, best_budget, best_pub_waarde;
    
    
    public schilderijen () {
        try {
            //st = new StreamTokenizer(new FileReader("schilderijen.in"));
            st = new StreamTokenizer(new InputStreamReader(System.in));
            st.nextToken(); int runs = (int)st.nval;
            while (runs-- > 0) {
                st.nextToken(); max_budget = (int)st.nval;
                budget = 0;
                pub_waarde = 0; best_pub_waarde = 0;
                aantal_m = 0;
                st.nextToken(); m = (int)st.nval;
                ma = new int[m][4];
                for (int i = 0; i < m; i++) {
                    st.nextToken(); ma[i][0] = (int)st.nval - 10;
                    st.nextToken(); ma[i][1] = (int)st.nval;
                    ma[i][2] = 0; ma[i][3] = 0;
                }
                st.nextToken(); s = (int)st.nval;
                sa = new int[s][4];
                for (int i = 0; i < s; i++) {
                    st.nextToken(); sa[i][0] = (int)st.nval + 10;
                    st.nextToken(); sa[i][1] = (int)st.nval;
                    st.nextToken(); sa[i][2] = (int)st.nval;
                    sa[i][3] = 0;
                }
                this.backtrack();
                System.out.println(best_budget + " " + best_pub_waarde);
            }
        }
        catch (IOException e) {
            System.err.println(e + " exception in schilderijen.");
        }
    }
      
    
    private void backtrack () {
        if ((pub_waarde > best_pub_waarde) || (pub_waarde == best_pub_waarde && budget < best_budget)) {
            best_pub_waarde = pub_waarde;
            best_budget = budget;
        }
        for (int i = 0; i < s; i++) {
            if (sa[i][3] == 0 && max_budget >= budget + sa[i][1]) {
                for (int j = 0; j < m; j++) {
                    if (ma[j][2] < MAX_S && sa[i][0] <= ma[j][0]) {
                        if (ma[j][3] == 1) {
                            sa[i][3] = 1;                   // dit schilderij is in gebruik
                            ma[j][0] -= sa[i][0];           // de muur krijgt minder lege ruimte
                            ma[j][2]++;                     // de muur krijgt er een schilderij bij
                            budget += sa[i][1];             // het besteedde budget gaat omhoog
                            pub_waarde += sa[i][2];         // de publiekswaarde wordt groter
                            this.backtrack();               // we gaan verder proberen
                            pub_waarde -= sa[i][2];
                            budget -= sa[i][1];
                            ma[j][2]--;
                            ma[j][0] += sa[i][0];
                            sa[i][3] = 0;
                        }
                        else if (aantal_m < MAX_M && max_budget >= budget + sa[i][1] + ma[j][1]) {
                            aantal_m++;
                            ma[j][3] = 1;                   // deze muur is in gebruik
                            sa[i][3] = 1;                   // dit schilderij is in gebruik
                            ma[j][0] -= sa[i][0];           // de muur krijgt minder lege ruimte
                            ma[j][2]++;                     // de muur krijgt er een schilderij bij
                            budget += sa[i][1] + ma[j][1];  // het besteedde budget gaat omhoog
                            pub_waarde += sa[i][2];         // de publiekswaarde wordt groter
                            this.backtrack();               // we gaan verder proberen
                            pub_waarde -= sa[i][2];
                            budget -= sa[i][1] + ma[j][1];
                            ma[j][2]--;
                            ma[j][0] += sa[i][0];
                            sa[i][3] = 0;
                            ma[j][3] = 0;
                            aantal_m--;
                        }
                    }
                }
            }
        }
    }
    
}