#include <stdio.h>
#include <stdlib.h>


int runs, b, h, nr;
int set[100][20];
int set_fout[100];
int nr_fout;


void printfoutesleutel (int i) {			    // PRINT EEN SLEUTEL OP HET SCHERM
    for (int j = 0; j < b; j++) {			    // Print voor de gehele breedte van de sleutel..
        printf("%d",set[set_fout[i]][j]);		    // ..de aldaar aanwezige hoogte
    }
}


void go () {						    // VOERT EEN RUN UIT
    nr_fout = 0;					    // We beginnen met nul foute sleutels.
    bool ok1, ok2;
    for (int i = 0; i < nr; i++) {		            // Ga alle sleutels af
        ok1 = true;
        for (int j = 0; j < nr && ok1; j++) {	            // Vergelijk met alle andere sleutels
            if (i != j) {				    // Alleen andere sleutels dus
                ok2 = false;
                for (int k = 0; k < b && !ok2; k++) {	    // Vergelijk de gehele breedte
                    if (set[i][k] < set[j][k]) ok2 = true;
                }
                if (!ok2) ok1 = false;
            }
        }
        if (!ok1) {					    // Een foute sleutel voegen we toe aan de lijst met foute sleutels
            set_fout[nr_fout] = i;
            nr_fout++;
        }
    }
    if (nr_fout == 0) printf("GOED");		            // Als we geen foute sleutels gevonden hebben...
    else {						    // Anders..
        printfoutesleutel(0);				    // ..printen we ze..
        for (int i = 1; i < nr_fout; i++) {		    // ..een voor een.
	    printf(" ");
	    printfoutesleutel(i);
	}
    }
    printf("\n");					    // Print nog een enter achter iedere run.
}


int main (void) {					    // DE HOOFDLUS

//    FILE* file = fopen("a.in","r");			    // Open het invoerbestand.
    FILE *file = stdin;
    fscanf(file,"%d\n",&runs);				    // Lees het aantal runs.
    char c;
    while (runs--) {					    // Voer alle runs uit.
        fscanf(file,"%d %d %d\n",&b,&h,&nr);		    // Lees breedte, hoogte en aantal sleutels in.
        //printf("we gaan de sleutels lezen\n");
        for (int i = 0; i < nr; i++) {			    // Lees voor iedere sleutel..
	    //printf("%d ",i); 
            for (int j = 0; j < b; j++) {		    // ..over de gehele breedte..
                fscanf(file,"%c",&c);    		    // de juiste hoogte in.
                //printf("%c",c);
                set[i][j] = atoi(&c);
            }
            fscanf(file,"\n");
            //printf("\n");
        }
        //printf("alles gelezen\n");
        go();						    // Ga deze run oplossen.
    }

    return 1;						    // Stop het programma.
}
