#include <stdio.h>

int is_prime(int n)
{
  int d;
  if (n<2) return 0;
  if (n%2==0) return (n==2);
  for(d=3;d*d<=n;d+=2)
    if (n%d==0)
      return 0;
  return 1;
}

int main(void)

{
  int A;

  for(scanf("%d",&A);A>0;A--) /* read & loop "A" times */
    {
      int p,N;

      scanf("%d",&N);    /* read and print "N" */
      printf("%d! =",N);

      for(p=2;p<=N;p++) /* walk primes up to & incl. "N" */
	if (is_prime(p))
	  {
	    int e=0,z=N; /* determine exponent of prime "p" in factorial(N) */

	    while(z) e+=(z/=p);
	    
	    if (p>2) printf(" *"); /* print p^e */
	    printf(" %d",p);
	    if (e>1) printf("^%d",e);

	  }
      printf("\n");
    }
  
  return 0;
}
