% This program reads the mobilia test.test files to check for the existence of solutions

start :- ['mobilia.pl'], read_inputfile.


read_inputfile :- see('test-prolog.in'),
                   write('Number of test cases: '),
                   read(N),
                   write(N), nl,
                   read(C),
                   processcase(N),
                   seen.



processcase(0).

processcase(N) :-
  readnextcase(B,MB),
  testsolution(B,MB,Sol),
  write('case '), write(N), nl,
  write('B = '),write(B),nl,
  write('MB = '), write(MB),nl,
  write('Sol = '), write(Sol), nl, nl,
  N1 is N-1,
  processcase(N1).


readnextcase(B,MB) :-
   read(X),
   processways(X,B,MB).


processways(b(X,Y),[(X,Y)|B],MB) :- read(Next),processways(Next,B,MB).
processways(mb(X,Y),B,[(X,Y)|MB]) :- read(Next),processways(Next,B,MB).
processways(case(X,Y),[],[]).
processways(stop,[],[]).


testsolution(B,MB,Sol) :-
    findsolution(B,MB,Sol).

testsolution(B,MB,'No solution').